package com.hai.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ApiStarbucksProductsExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public ApiStarbucksProductsExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdEqualTo(Long value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotEqualTo(Long value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThan(Long value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThan(Long value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIn(List<Long> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotIn(List<Long> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdBetween(Long value1, Long value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andNameIsNull() {
            addCriterion("`name` is null");
            return (Criteria) this;
        }

        public Criteria andNameIsNotNull() {
            addCriterion("`name` is not null");
            return (Criteria) this;
        }

        public Criteria andNameEqualTo(String value) {
            addCriterion("`name` =", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotEqualTo(String value) {
            addCriterion("`name` <>", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThan(String value) {
            addCriterion("`name` >", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThanOrEqualTo(String value) {
            addCriterion("`name` >=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThan(String value) {
            addCriterion("`name` <", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThanOrEqualTo(String value) {
            addCriterion("`name` <=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLike(String value) {
            addCriterion("`name` like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotLike(String value) {
            addCriterion("`name` not like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameIn(List<String> values) {
            addCriterion("`name` in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotIn(List<String> values) {
            addCriterion("`name` not in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameBetween(String value1, String value2) {
            addCriterion("`name` between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("`name` not between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andDesIsNull() {
            addCriterion("des is null");
            return (Criteria) this;
        }

        public Criteria andDesIsNotNull() {
            addCriterion("des is not null");
            return (Criteria) this;
        }

        public Criteria andDesEqualTo(String value) {
            addCriterion("des =", value, "des");
            return (Criteria) this;
        }

        public Criteria andDesNotEqualTo(String value) {
            addCriterion("des <>", value, "des");
            return (Criteria) this;
        }

        public Criteria andDesGreaterThan(String value) {
            addCriterion("des >", value, "des");
            return (Criteria) this;
        }

        public Criteria andDesGreaterThanOrEqualTo(String value) {
            addCriterion("des >=", value, "des");
            return (Criteria) this;
        }

        public Criteria andDesLessThan(String value) {
            addCriterion("des <", value, "des");
            return (Criteria) this;
        }

        public Criteria andDesLessThanOrEqualTo(String value) {
            addCriterion("des <=", value, "des");
            return (Criteria) this;
        }

        public Criteria andDesLike(String value) {
            addCriterion("des like", value, "des");
            return (Criteria) this;
        }

        public Criteria andDesNotLike(String value) {
            addCriterion("des not like", value, "des");
            return (Criteria) this;
        }

        public Criteria andDesIn(List<String> values) {
            addCriterion("des in", values, "des");
            return (Criteria) this;
        }

        public Criteria andDesNotIn(List<String> values) {
            addCriterion("des not in", values, "des");
            return (Criteria) this;
        }

        public Criteria andDesBetween(String value1, String value2) {
            addCriterion("des between", value1, value2, "des");
            return (Criteria) this;
        }

        public Criteria andDesNotBetween(String value1, String value2) {
            addCriterion("des not between", value1, value2, "des");
            return (Criteria) this;
        }

        public Criteria andDefaultImageIsNull() {
            addCriterion("default_image is null");
            return (Criteria) this;
        }

        public Criteria andDefaultImageIsNotNull() {
            addCriterion("default_image is not null");
            return (Criteria) this;
        }

        public Criteria andDefaultImageEqualTo(String value) {
            addCriterion("default_image =", value, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageNotEqualTo(String value) {
            addCriterion("default_image <>", value, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageGreaterThan(String value) {
            addCriterion("default_image >", value, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageGreaterThanOrEqualTo(String value) {
            addCriterion("default_image >=", value, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageLessThan(String value) {
            addCriterion("default_image <", value, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageLessThanOrEqualTo(String value) {
            addCriterion("default_image <=", value, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageLike(String value) {
            addCriterion("default_image like", value, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageNotLike(String value) {
            addCriterion("default_image not like", value, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageIn(List<String> values) {
            addCriterion("default_image in", values, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageNotIn(List<String> values) {
            addCriterion("default_image not in", values, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageBetween(String value1, String value2) {
            addCriterion("default_image between", value1, value2, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andDefaultImageNotBetween(String value1, String value2) {
            addCriterion("default_image not between", value1, value2, "defaultImage");
            return (Criteria) this;
        }

        public Criteria andCupSizeIsNull() {
            addCriterion("cup_size is null");
            return (Criteria) this;
        }

        public Criteria andCupSizeIsNotNull() {
            addCriterion("cup_size is not null");
            return (Criteria) this;
        }

        public Criteria andCupSizeEqualTo(String value) {
            addCriterion("cup_size =", value, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeNotEqualTo(String value) {
            addCriterion("cup_size <>", value, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeGreaterThan(String value) {
            addCriterion("cup_size >", value, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeGreaterThanOrEqualTo(String value) {
            addCriterion("cup_size >=", value, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeLessThan(String value) {
            addCriterion("cup_size <", value, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeLessThanOrEqualTo(String value) {
            addCriterion("cup_size <=", value, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeLike(String value) {
            addCriterion("cup_size like", value, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeNotLike(String value) {
            addCriterion("cup_size not like", value, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeIn(List<String> values) {
            addCriterion("cup_size in", values, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeNotIn(List<String> values) {
            addCriterion("cup_size not in", values, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeBetween(String value1, String value2) {
            addCriterion("cup_size between", value1, value2, "cupSize");
            return (Criteria) this;
        }

        public Criteria andCupSizeNotBetween(String value1, String value2) {
            addCriterion("cup_size not between", value1, value2, "cupSize");
            return (Criteria) this;
        }

        public Criteria andTemperatureIsNull() {
            addCriterion("temperature is null");
            return (Criteria) this;
        }

        public Criteria andTemperatureIsNotNull() {
            addCriterion("temperature is not null");
            return (Criteria) this;
        }

        public Criteria andTemperatureEqualTo(String value) {
            addCriterion("temperature =", value, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureNotEqualTo(String value) {
            addCriterion("temperature <>", value, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureGreaterThan(String value) {
            addCriterion("temperature >", value, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureGreaterThanOrEqualTo(String value) {
            addCriterion("temperature >=", value, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureLessThan(String value) {
            addCriterion("temperature <", value, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureLessThanOrEqualTo(String value) {
            addCriterion("temperature <=", value, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureLike(String value) {
            addCriterion("temperature like", value, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureNotLike(String value) {
            addCriterion("temperature not like", value, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureIn(List<String> values) {
            addCriterion("temperature in", values, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureNotIn(List<String> values) {
            addCriterion("temperature not in", values, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureBetween(String value1, String value2) {
            addCriterion("temperature between", value1, value2, "temperature");
            return (Criteria) this;
        }

        public Criteria andTemperatureNotBetween(String value1, String value2) {
            addCriterion("temperature not between", value1, value2, "temperature");
            return (Criteria) this;
        }

        public Criteria andCreamIsNull() {
            addCriterion("cream is null");
            return (Criteria) this;
        }

        public Criteria andCreamIsNotNull() {
            addCriterion("cream is not null");
            return (Criteria) this;
        }

        public Criteria andCreamEqualTo(String value) {
            addCriterion("cream =", value, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamNotEqualTo(String value) {
            addCriterion("cream <>", value, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamGreaterThan(String value) {
            addCriterion("cream >", value, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamGreaterThanOrEqualTo(String value) {
            addCriterion("cream >=", value, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamLessThan(String value) {
            addCriterion("cream <", value, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamLessThanOrEqualTo(String value) {
            addCriterion("cream <=", value, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamLike(String value) {
            addCriterion("cream like", value, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamNotLike(String value) {
            addCriterion("cream not like", value, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamIn(List<String> values) {
            addCriterion("cream in", values, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamNotIn(List<String> values) {
            addCriterion("cream not in", values, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamBetween(String value1, String value2) {
            addCriterion("cream between", value1, value2, "cream");
            return (Criteria) this;
        }

        public Criteria andCreamNotBetween(String value1, String value2) {
            addCriterion("cream not between", value1, value2, "cream");
            return (Criteria) this;
        }

        public Criteria andEspressoIsNull() {
            addCriterion("espresso is null");
            return (Criteria) this;
        }

        public Criteria andEspressoIsNotNull() {
            addCriterion("espresso is not null");
            return (Criteria) this;
        }

        public Criteria andEspressoEqualTo(String value) {
            addCriterion("espresso =", value, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoNotEqualTo(String value) {
            addCriterion("espresso <>", value, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoGreaterThan(String value) {
            addCriterion("espresso >", value, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoGreaterThanOrEqualTo(String value) {
            addCriterion("espresso >=", value, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoLessThan(String value) {
            addCriterion("espresso <", value, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoLessThanOrEqualTo(String value) {
            addCriterion("espresso <=", value, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoLike(String value) {
            addCriterion("espresso like", value, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoNotLike(String value) {
            addCriterion("espresso not like", value, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoIn(List<String> values) {
            addCriterion("espresso in", values, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoNotIn(List<String> values) {
            addCriterion("espresso not in", values, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoBetween(String value1, String value2) {
            addCriterion("espresso between", value1, value2, "espresso");
            return (Criteria) this;
        }

        public Criteria andEspressoNotBetween(String value1, String value2) {
            addCriterion("espresso not between", value1, value2, "espresso");
            return (Criteria) this;
        }

        public Criteria andMilkIsNull() {
            addCriterion("milk is null");
            return (Criteria) this;
        }

        public Criteria andMilkIsNotNull() {
            addCriterion("milk is not null");
            return (Criteria) this;
        }

        public Criteria andMilkEqualTo(String value) {
            addCriterion("milk =", value, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkNotEqualTo(String value) {
            addCriterion("milk <>", value, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkGreaterThan(String value) {
            addCriterion("milk >", value, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkGreaterThanOrEqualTo(String value) {
            addCriterion("milk >=", value, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkLessThan(String value) {
            addCriterion("milk <", value, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkLessThanOrEqualTo(String value) {
            addCriterion("milk <=", value, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkLike(String value) {
            addCriterion("milk like", value, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkNotLike(String value) {
            addCriterion("milk not like", value, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkIn(List<String> values) {
            addCriterion("milk in", values, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkNotIn(List<String> values) {
            addCriterion("milk not in", values, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkBetween(String value1, String value2) {
            addCriterion("milk between", value1, value2, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkNotBetween(String value1, String value2) {
            addCriterion("milk not between", value1, value2, "milk");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleIsNull() {
            addCriterion("milk_bubble is null");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleIsNotNull() {
            addCriterion("milk_bubble is not null");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleEqualTo(String value) {
            addCriterion("milk_bubble =", value, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleNotEqualTo(String value) {
            addCriterion("milk_bubble <>", value, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleGreaterThan(String value) {
            addCriterion("milk_bubble >", value, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleGreaterThanOrEqualTo(String value) {
            addCriterion("milk_bubble >=", value, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleLessThan(String value) {
            addCriterion("milk_bubble <", value, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleLessThanOrEqualTo(String value) {
            addCriterion("milk_bubble <=", value, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleLike(String value) {
            addCriterion("milk_bubble like", value, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleNotLike(String value) {
            addCriterion("milk_bubble not like", value, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleIn(List<String> values) {
            addCriterion("milk_bubble in", values, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleNotIn(List<String> values) {
            addCriterion("milk_bubble not in", values, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleBetween(String value1, String value2) {
            addCriterion("milk_bubble between", value1, value2, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andMilkBubbleNotBetween(String value1, String value2) {
            addCriterion("milk_bubble not between", value1, value2, "milkBubble");
            return (Criteria) this;
        }

        public Criteria andCategoryNameIsNull() {
            addCriterion("category_name is null");
            return (Criteria) this;
        }

        public Criteria andCategoryNameIsNotNull() {
            addCriterion("category_name is not null");
            return (Criteria) this;
        }

        public Criteria andCategoryNameEqualTo(String value) {
            addCriterion("category_name =", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameNotEqualTo(String value) {
            addCriterion("category_name <>", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameGreaterThan(String value) {
            addCriterion("category_name >", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameGreaterThanOrEqualTo(String value) {
            addCriterion("category_name >=", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameLessThan(String value) {
            addCriterion("category_name <", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameLessThanOrEqualTo(String value) {
            addCriterion("category_name <=", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameLike(String value) {
            addCriterion("category_name like", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameNotLike(String value) {
            addCriterion("category_name not like", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameIn(List<String> values) {
            addCriterion("category_name in", values, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameNotIn(List<String> values) {
            addCriterion("category_name not in", values, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameBetween(String value1, String value2) {
            addCriterion("category_name between", value1, value2, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameNotBetween(String value1, String value2) {
            addCriterion("category_name not between", value1, value2, "categoryName");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceIsNull() {
            addCriterion("market_tall_price is null");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceIsNotNull() {
            addCriterion("market_tall_price is not null");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceEqualTo(BigDecimal value) {
            addCriterion("market_tall_price =", value, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceNotEqualTo(BigDecimal value) {
            addCriterion("market_tall_price <>", value, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceGreaterThan(BigDecimal value) {
            addCriterion("market_tall_price >", value, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("market_tall_price >=", value, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceLessThan(BigDecimal value) {
            addCriterion("market_tall_price <", value, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("market_tall_price <=", value, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceIn(List<BigDecimal> values) {
            addCriterion("market_tall_price in", values, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceNotIn(List<BigDecimal> values) {
            addCriterion("market_tall_price not in", values, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("market_tall_price between", value1, value2, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketTallPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("market_tall_price not between", value1, value2, "marketTallPrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceIsNull() {
            addCriterion("market_grande_price is null");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceIsNotNull() {
            addCriterion("market_grande_price is not null");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceEqualTo(BigDecimal value) {
            addCriterion("market_grande_price =", value, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceNotEqualTo(BigDecimal value) {
            addCriterion("market_grande_price <>", value, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceGreaterThan(BigDecimal value) {
            addCriterion("market_grande_price >", value, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("market_grande_price >=", value, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceLessThan(BigDecimal value) {
            addCriterion("market_grande_price <", value, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("market_grande_price <=", value, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceIn(List<BigDecimal> values) {
            addCriterion("market_grande_price in", values, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceNotIn(List<BigDecimal> values) {
            addCriterion("market_grande_price not in", values, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("market_grande_price between", value1, value2, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketGrandePriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("market_grande_price not between", value1, value2, "marketGrandePrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceIsNull() {
            addCriterion("market_venti_price is null");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceIsNotNull() {
            addCriterion("market_venti_price is not null");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceEqualTo(BigDecimal value) {
            addCriterion("market_venti_price =", value, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceNotEqualTo(BigDecimal value) {
            addCriterion("market_venti_price <>", value, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceGreaterThan(BigDecimal value) {
            addCriterion("market_venti_price >", value, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("market_venti_price >=", value, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceLessThan(BigDecimal value) {
            addCriterion("market_venti_price <", value, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("market_venti_price <=", value, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceIn(List<BigDecimal> values) {
            addCriterion("market_venti_price in", values, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceNotIn(List<BigDecimal> values) {
            addCriterion("market_venti_price not in", values, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("market_venti_price between", value1, value2, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andMarketVentiPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("market_venti_price not between", value1, value2, "marketVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceIsNull() {
            addCriterion("sales_tall_price is null");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceIsNotNull() {
            addCriterion("sales_tall_price is not null");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceEqualTo(BigDecimal value) {
            addCriterion("sales_tall_price =", value, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceNotEqualTo(BigDecimal value) {
            addCriterion("sales_tall_price <>", value, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceGreaterThan(BigDecimal value) {
            addCriterion("sales_tall_price >", value, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sales_tall_price >=", value, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceLessThan(BigDecimal value) {
            addCriterion("sales_tall_price <", value, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sales_tall_price <=", value, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceIn(List<BigDecimal> values) {
            addCriterion("sales_tall_price in", values, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceNotIn(List<BigDecimal> values) {
            addCriterion("sales_tall_price not in", values, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sales_tall_price between", value1, value2, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesTallPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sales_tall_price not between", value1, value2, "salesTallPrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceIsNull() {
            addCriterion("sales_grande_price is null");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceIsNotNull() {
            addCriterion("sales_grande_price is not null");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceEqualTo(BigDecimal value) {
            addCriterion("sales_grande_price =", value, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceNotEqualTo(BigDecimal value) {
            addCriterion("sales_grande_price <>", value, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceGreaterThan(BigDecimal value) {
            addCriterion("sales_grande_price >", value, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sales_grande_price >=", value, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceLessThan(BigDecimal value) {
            addCriterion("sales_grande_price <", value, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sales_grande_price <=", value, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceIn(List<BigDecimal> values) {
            addCriterion("sales_grande_price in", values, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceNotIn(List<BigDecimal> values) {
            addCriterion("sales_grande_price not in", values, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sales_grande_price between", value1, value2, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesGrandePriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sales_grande_price not between", value1, value2, "salesGrandePrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceIsNull() {
            addCriterion("sales_venti_price is null");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceIsNotNull() {
            addCriterion("sales_venti_price is not null");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceEqualTo(BigDecimal value) {
            addCriterion("sales_venti_price =", value, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceNotEqualTo(BigDecimal value) {
            addCriterion("sales_venti_price <>", value, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceGreaterThan(BigDecimal value) {
            addCriterion("sales_venti_price >", value, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sales_venti_price >=", value, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceLessThan(BigDecimal value) {
            addCriterion("sales_venti_price <", value, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sales_venti_price <=", value, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceIn(List<BigDecimal> values) {
            addCriterion("sales_venti_price in", values, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceNotIn(List<BigDecimal> values) {
            addCriterion("sales_venti_price not in", values, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sales_venti_price between", value1, value2, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andSalesVentiPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sales_venti_price not between", value1, value2, "salesVentiPrice");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIsNull() {
            addCriterion("operator_id is null");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIsNotNull() {
            addCriterion("operator_id is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorIdEqualTo(Long value) {
            addCriterion("operator_id =", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotEqualTo(Long value) {
            addCriterion("operator_id <>", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdGreaterThan(Long value) {
            addCriterion("operator_id >", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdGreaterThanOrEqualTo(Long value) {
            addCriterion("operator_id >=", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdLessThan(Long value) {
            addCriterion("operator_id <", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdLessThanOrEqualTo(Long value) {
            addCriterion("operator_id <=", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIn(List<Long> values) {
            addCriterion("operator_id in", values, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotIn(List<Long> values) {
            addCriterion("operator_id not in", values, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdBetween(Long value1, Long value2) {
            addCriterion("operator_id between", value1, value2, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotBetween(Long value1, Long value2) {
            addCriterion("operator_id not between", value1, value2, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIsNull() {
            addCriterion("operator_name is null");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIsNotNull() {
            addCriterion("operator_name is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorNameEqualTo(String value) {
            addCriterion("operator_name =", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotEqualTo(String value) {
            addCriterion("operator_name <>", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameGreaterThan(String value) {
            addCriterion("operator_name >", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameGreaterThanOrEqualTo(String value) {
            addCriterion("operator_name >=", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLessThan(String value) {
            addCriterion("operator_name <", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLessThanOrEqualTo(String value) {
            addCriterion("operator_name <=", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLike(String value) {
            addCriterion("operator_name like", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotLike(String value) {
            addCriterion("operator_name not like", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIn(List<String> values) {
            addCriterion("operator_name in", values, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotIn(List<String> values) {
            addCriterion("operator_name not in", values, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameBetween(String value1, String value2) {
            addCriterion("operator_name between", value1, value2, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotBetween(String value1, String value2) {
            addCriterion("operator_name not between", value1, value2, "operatorName");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}